#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wchar.h>
#include <locale.h>

// UNICODE (UTF-8) символьные строки:

//----------------------------------------------------------

void test01( void ) {
   printf( "размер символа wchar_t в реализации = %d байт\n", sizeof( wchar_t ) );
}

//-----------------------------------------------------

void test02( void ) {
   char *loc = setlocale( LC_ALL, NULL );   // показать текущую локаль
   printf( "локаль программы по умолчанию: %s\n", loc );
}

//-----------------------------------------------------

const char buf[] = "тестовая русскоязычная UTF-8 строка";

void test03( void ) {
   wchar_t wbuf[ 40 ];
   char *loc = setlocale( LC_ALL, "" );  // только после этого работают преобразования!
   int n = -1, i;
   char *p;
   printf( "преобразование UTF-8 символов в широкие (wchar_t):\n" );
   printf( "локаль программы установлена: %s\n", loc );
   printf( "строка UTF-8 до преобразования: '%s'\n"
           "длина UTF-8 строки = %d байт\n",
           buf, strlen( buf ) );
   for( i = 0, p = (char*)buf; n != 0; i++ ) 
      p += ( n = mbtowc( wbuf + i, p, MB_CUR_MAX ) );
   printf( "преобразованная строка: '%ls'\n"
           "длина преобразованной строки = %d символов\n",
           wbuf, wcslen( wbuf ) );
}

//-----------------------------------------------------

void ( *tests[] )( void ) = {  // последовательность тестов
        test01,
        test02,
        test03,
};
#include "main.c"

